var CAT_PLUGIN = CAT_PLUGIN || {};
var MINIMUM_COMMIT_TO_SHOW_PROJECT  = 10;
var MINIMUM_COMMIT_TO_SHOW_SCOPE  = 5;
var NO_OF_COMMIT_ON_SHOW_MORE = 5;
var MINIMUM_COMMIT_TO_SHOW = 2;
var currentIndexRows = MINIMUM_COMMIT_TO_SHOW;
var RepoUtil = {};

var invokePropertyFile = function(){
	//Loading properties for internationalization
	jQuery.i18n.properties({
		name: "messages", 
		path: $('#repoPluginBasePath').val()+"/resources/svnResourceStrings/", 
		mode: 'both', 
		language :PLUGIN_UTIL.getLanguage()
	});
}

var showFileDetails = function(context) {
	var me = $(context);
	var imageExpandClass = me.find('.commitRec-img-expand');
	var imageCollapseClass = me.find('.commitRec-img-collapse');
	if (imageExpandClass.hasClass('on')) {
		imageExpandClass.removeClass('on').hide();
		imageCollapseClass.addClass('on').show();
	}else{
		imageCollapseClass.removeClass('on').hide();
		imageExpandClass.addClass('on').show();
	}
	var parentTr = me.closest('tr');
	parentTr.next('tr').toggle();
};

var initialCommitView = function() {
	$(".svnCommitTable").each(function() {
		var that = $(this);
		var screenType = that.find('#pluginScreenType').val();
		//console.log("screenType "+screenType);
		if(screenType == "SCOPE"){
			MINIMUM_COMMIT_TO_SHOW = MINIMUM_COMMIT_TO_SHOW_SCOPE;
		}else{
			MINIMUM_COMMIT_TO_SHOW = MINIMUM_COMMIT_TO_SHOW_PROJECT;
		}
		var $records = that.find("tr.repositoryCommitDataRows");
		//console.log("Records "+$records.length);
		if($records.length > MINIMUM_COMMIT_TO_SHOW){
			that.find('.show-more-commit-row').show();
			//console.log(that.find('tr.repositoryCommitDataRows:gt('+(MINIMUM_COMMIT_TO_SHOW - 1)+')'));
			if(screenType == "SCOPE"){
				that.find('tr.repositoryCommitDataRows:gt('+(MINIMUM_COMMIT_TO_SHOW - 1)+')').hide();
				that.find('tr.repositoryCommitDataRowsMessage:gt('+(MINIMUM_COMMIT_TO_SHOW - 1)+')').hide();
				that.find('tr.repositoryCommitDataRowsFileSize:gt('+(MINIMUM_COMMIT_TO_SHOW - 1)+')').hide();
			}else{
				that.find('tr.repositoryCommitDataRows:gt('+(MINIMUM_COMMIT_TO_SHOW - 1)+')').hide();
			}
		}
	});
}

var displayMoreCommitRecords = function(context) {
	var thisObj = $(context);
	var currentTable = thisObj.closest('#repositoryCommitTable');
	var screenType = currentTable.find('#pluginScreenType').val();
	var $totalRecords = currentTable.find("tr.repositoryCommitDataRows");
	var $visibleRecords = currentTable.find("tr.repositoryCommitDataRows:visible");
	var currentIndexRows = $visibleRecords.length; 
	//console.log("Visible Records :"+$totalRecords.length+" ",$visibleRecords.length);
	if($visibleRecords.length < $totalRecords.length){
		if(screenType == "SCOPE"){
			currentTable.find("tr.repositoryCommitDataRows").slice(currentIndexRows, currentIndexRows + NO_OF_COMMIT_ON_SHOW_MORE).show();
			currentTable.find("tr.repositoryCommitDataRowsMessage").slice(currentIndexRows, currentIndexRows + NO_OF_COMMIT_ON_SHOW_MORE).show();
			currentTable.find("tr.repositoryCommitDataRowsFileSize").slice(currentIndexRows, currentIndexRows + NO_OF_COMMIT_ON_SHOW_MORE).show();
		}else{
			currentTable.find("tr.repositoryCommitDataRows").slice(currentIndexRows, currentIndexRows + NO_OF_COMMIT_ON_SHOW_MORE).show();	
		}
		currentIndexRows += NO_OF_COMMIT_ON_SHOW_MORE;
		$visibleRecords = currentTable.find("tr.repositoryCommitDataRows:visible");
		if($visibleRecords.length == $totalRecords.length){
			thisObj.hide();
			currentTable.find('.show-less-commit-row').show();
		}
	}
}

var displayLessCommitRecords = function(context) {
	var that = $(context);
	var currentTable = that.closest('#repositoryCommitTable');
	var screenType = currentTable.find('#pluginScreenType').val();
	if(screenType == "SCOPE"){
		MINIMUM_COMMIT_TO_SHOW = MINIMUM_COMMIT_TO_SHOW_SCOPE;
	}else{
		MINIMUM_COMMIT_TO_SHOW = MINIMUM_COMMIT_TO_SHOW_PROJECT;
	}
	var $records = currentTable.find("tr.repositoryCommitDataRows");
	//console.log("Records "+$records.length);
	if($records.length > MINIMUM_COMMIT_TO_SHOW){
		currentTable.find('.show-more-commit-row').show();
		currentTable.find('.show-less-commit-row').hide();
		//console.log(that.find('tr.repositoryCommitDataRows:gt('+(MINIMUM_COMMIT_TO_SHOW - 1)+')'));
		if(screenType == "SCOPE"){
			currentTable.find('tr.repositoryCommitDataRows:gt('+(MINIMUM_COMMIT_TO_SHOW - 1)+')').hide();
			currentTable.find('tr.repositoryCommitDataRowsMessage:gt('+(MINIMUM_COMMIT_TO_SHOW - 1)+')').hide();
			currentTable.find('tr.repositoryCommitDataRowsFileSize:gt('+(MINIMUM_COMMIT_TO_SHOW - 1)+')').hide();
		}else{
			currentTable.find('tr.repositoryCommitDataRows:gt('+(MINIMUM_COMMIT_TO_SHOW - 1)+')').hide();
		}
	}
}

var loadFileDetailsForComparison = function(eventTarget, fieldData, repoDiffContentId) {
	$.ajax({
		method: 'GET',
		url: $('#repoPluginBasePath').val() + '/getFileComparison',
		data: fieldData,
		dataType: "json",
		cache: false,
		success : function(response) {
			//console.log("File Response",response);
			//console.log("File Format",response.svnFileDetails.validFileFormatFlg);
			if(response.svnFileDetails.validFileFormatFlg == "VALID"){
				var win = Ext.first('#repoDiffWin');
				if (win) {
					if (win.requestId != response.svnFileDetails.requestId)
						return ; // drop old response

					// get the baseText and newText values from the two textboxes, and split them into lines
					var base = difflib.stringAsLines(response.svnFileDetails.oldFileContents);
					var newtxt = difflib.stringAsLines(response.svnFileDetails.newFileContents);
	
					// create a SequenceMatcher instance that diffs the two sets of lines
					var sm = new difflib.SequenceMatcher(base, newtxt);
	
					// get the opcodes from the SequenceMatcher instance
					// opcodes is a list of 3-tuples describing what changes should be made to the base text
					// in order to yield the new text
					var opcodes = sm.get_opcodes();
					var fileDiffContent = diffview.buildView({
						baseTextLines: base,
						newTextLines: newtxt,
						opcodes: opcodes,
						baseTextName: "Rev: " + response.svnFileDetails.previousRepoRevision,
						newTextName: "Rev: " + response.svnFileDetails.repositoryRevision,
						//viewType: $("inline").checked ? 1 : 0
						viewType: 0 // left and right view
					});
					$('#'+repoDiffContentId).addClass('addMergin');
					$('#'+repoDiffContentId).html(fileDiffContent);
					// diff summary view
					var summaryView = RepoUtil.createDiffSummaryView(fileDiffContent);
					$('#diffSummary').html(summaryView);
					$('#diffSummary').show();
					RepoUtil.registerDiffSummaryHandler('#diffSummary');
					//
					var title = win.getTitle();
					win.setTitle(title + '&nbsp;&nbsp;' + Ext.htmlEncode(response.svnFileDetails.fileName));
					win.showedDiffContents(win);
				}
			} else {
				var errorMsgBody;
				if ($('#repoConnectErrorDiv').length > 0 ) {
					errorMsgBody = plugin.svnTab.error.repoConnectError;
			    }else if(response.svnFileDetails.validFileFormatFlg == "DIR"){
					errorMsgBody = plugin.svnTab.fileComparison.invalidFormatDir;
				} else if(response.svnFileDetails.validFileFormatFlg == "OVERSIZE") {
					errorMsgBody = plugin.svnTab.fileComparison.invalidOverSize;
				}else{
					errorMsgBody = plugin.svnTab.fileComparison.invalidFileFormat
				}
				var win = Ext.first('#repoDiffWin');
				if (win) {
					win.close();
				}
				F.pluginDialog(plugin.svn.testConnectionMessage.testConnectionResultFail.errorLabel, errorMsgBody, 
						"", plugin.svn.htmlLabel.closeButtonLabel, "error", false, {
					width : 500,
				});
			}
		},
		error : function(XMLHttpRequest, textStatus, errorThrown) {
			$('#loadingView').hide();
		}
	});
}

RepoUtil.createDiffSummaryView = function(fileDiffContent) {
	var changeLines = [], prev = 0;
	$('tr', fileDiffContent).each(function(idx, el){
		if (idx == 0)
			return;
		if($('td.equal', this).length == 2) {
			changeLines.push(0);
			prev = 0;
		} else {
			changeLines.push(idx);
			if (prev == 0)
				$(this).addClass('jump-line-'+idx);
			prev = 1;
		}		
	});
	// calc changing for n/100% -> n/(UNIT_SIZE*SCALE)%
	var SCALE = 1, UNIT_SIZE = 100 * SCALE, changeOfUnit = [];
	for (var i=0; i<UNIT_SIZE; i++) // init
		changeOfUnit[i] = -1;
	var len = changeLines.length, idxOfUnit;
	for (var i=0; i<len; i++) {
		idxOfUnit = (i * UNIT_SIZE / len)|0; // same with Math.floor
		if (changeOfUnit[idxOfUnit] === -1) // set only when it is empty
			changeOfUnit[idxOfUnit] = changeLines[i];
		else if (changeOfUnit[idxOfUnit] === 0)
			changeOfUnit[idxOfUnit] = changeLines[i];
	}
	var prevVal = changeOfUnit[0];
	for (var i=1; i<UNIT_SIZE; i++) {
		if (changeOfUnit[i] == -1)
			changeOfUnit[i] = prevVal;
		else
			prevVal = changeOfUnit[i]; 
	}
	var summaryView = '', curState = changeOfUnit[0], curSeqCount=1, seqFirst=0, opt;
	for (var i=1; i<UNIT_SIZE; i++) {
		if ((curState > 0 && changeOfUnit[i] <= 0) || (curState <= 0 && changeOfUnit[i] > 0)) {
			summaryView += RepoUtil.appendSpaceArea(SCALE, curState, seqFirst, curSeqCount);
			curState = changeOfUnit[i];
			curSeqCount = 1;
			seqFirst = i;
		} else {
			curSeqCount += 1;
		}							
	}
	summaryView += RepoUtil.appendSpaceArea(SCALE, curState, seqFirst, curSeqCount);
	//console.log('changeOfUnit=',changeOfUnit);
	//console.log('summaryDiv=',summaryView);
	return summaryView;
}

RepoUtil.appendSpaceArea = function(SCALE, curState, seqFirst, curSeqCount) {
	var opt = '';
	if (curState > 0)
		opt = 'class="summary-diff-pos" data-pos="'+curState+'"';
	return '<div '+opt+' style="height:'+curSeqCount/SCALE+'%"></div>';
}

RepoUtil.registerDiffSummaryHandler = function(baseId) {
	$(baseId + ' .summary-diff-pos').on('click', function(e){
		var $this = $(this),
			pos = $this.data('pos'),
			scrollTarget = $('#repoDiffContent'),
			curPos = scrollTarget.scrollTop(),
			targetPos = $('.repositoryFileDiffTable .jump-line-'+pos).position().top,
			newPos = curPos + targetPos - 20;
			speed = (Math.abs(curPos - newPos) > 400) ? 300 : 100;
		//scrollTarget.scrollTop(newPos);
		scrollTarget.animate({scrollTop:newPos}, speed, 'swing');
	});
}

CAT_PLUGIN.init = function() {

	var me = this,
		
	params = {
		serviceId : $("#__pluginServiceId").val(),
		projectId: $('#__pluginProjectId').val(),
		bugId: $('#__pluginBugId').val(),
		projectKey: $('#__pluginBts-id').val().trim().split('-')[0],
		filter: $('#__pluginKey').val(),
		repoPluginEventScreen : $('#repoPluginEventScreen').val()
	};
	
	$.ajax({
		method: 'GET',
		url: $('#repoPluginBasePath').val() + '/loadSvnTabBody',
		data: params,
		dataType: 'html',
		cache: false,
		success: function(response) {
			
			var screenType = $('#repoPluginEventScreen').val();
			if(screenType === "SCOPE"){
				$('.scopeSvnPluginContents').empty();
				$('.scopeSvnPluginContents').html(response);
			}else{
				$('.projectSvnPluginContents').empty();
				$('.projectSvnPluginContents').html(response);
			}
			
			invokePropertyFile();
			initialCommitView();
			$('.show-file-detail').click(function(){
				showFileDetails(this);
			});
			$('.show-more-commit-row').click(function() {
				displayMoreCommitRecords(this);
			});
			$('.show-less-commit-row').click(function() {
				displayLessCommitRecords(this);
			});
			$('.repo-filepath-link').click(onClickOpenDiff);
		},
		error : function(XMLHttpRequest, textStatus, errorThrown) {
			CATUtil.dialog.show({
    			title: 'ERROR',
    			msg: 'Server error happens. code='+XMLHttpRequest.status+', status='+textStatus,
    			icon: 'error'
    		});
		}
	});
};

onClickOpenDiff = function(e) {
	var thisObj = $(this);
	//var parentTr = thisObj.closest('tr');
	var currRevisionId = thisObj.find("input[name=revisionId]").val();
	var repositoryId = thisObj.find("input[name=repositoryId]").val();
	var serviceId = thisObj.find('#__pluginFileServiceId').val();
	var projectId = thisObj.find('#__pluginFileProjectId').val();
	var filePath = thisObj.find("input[name='fileFullPath']").val().trim();
	var fileType = thisObj.find("input[name='fileType']").val();
	var eventTarget = e.target;
	var fieldData = {
			revisionId: currRevisionId, 
			repositoryId: repositoryId,
			serviceId: serviceId,
			projectId: projectId,
			filePath: filePath,
			fileType: fileType
	};
	RepoUtil.openDiffWindow(eventTarget, fieldData);
}

RepoUtil.lockScroll = function() {
	var win = window;
    var scroll_position = [
        win.pageXOffset || win.document.documentElement.scrollLeft || win.document.body.scrollLeft,
        win.pageYOffset || win.document.documentElement.scrollTop  || win.document.body.scrollTop
    ];
    var html = win.$( 'html' );
    html.data( 'scroll_position', scroll_position );
    html.data( 'pre_overflow', html.css( 'overflow' ) );
    var before_body_width = win.$( 'body' ).outerWidth();
    html.css( 'overflow', 'hidden' );
    var after_body_width = win.$( 'body' ).outerWidth();
    if ( before_body_width < after_body_width ) {
        html.css( 'padding-right', F.scrollbar_width( win ) + 'px' );
    }
    win.scrollTo( scroll_position[0], scroll_position[1] );
    html.blur();
}

// スクロールを解除 -
RepoUtil.unlockScroll = function() {
	var win = window;
    var html = win.$( 'html' );
    if ( html.data( 'pre_overflow' ) ) {
        html.css( 'padding-right', 0 );
        html.css( 'overflow', html.data( 'pre_overflow' ) );
        var scroll_position = html.data( 'scroll_position' );
        win.scrollTo( scroll_position[0], scroll_position[1] );
    };
}

RepoUtil.openDiffWindow = function(target, fieldData) {
	target = target || document.body;
	var basePath = $('#repoPluginBasePath').val(),
		repoDiffContentId = 'repoDiffContent',
		loadingText = plugin.svn.label.common.pageloading,
		requestId = new Date().getTime() + '';
	fieldData.requestId = requestId;
	var win = Ext.create('Ext.window.Window', {
	    itemId: 'repoDiffWin',
	    requestId: requestId,
	    title: plugin.svnDiffWin.title,
	    width: 300,
	    height: 180,
	    modal: true,
	    maximizable: true,
	    //scrollable: true,
	    scrollable: false,
	    resizable: false,
	    keepCenter: true,
	    //animateTarget: target,
	    cls: 'repoPluginDiffWin',
	    bodyStyle: { borderWidth: 0, backgroundColor:'#fbfbfb' },
	    items: [{
	    	xtype: 'container',
	    	//html: fileDiffContent
	    	html: '<div id="'+repoDiffContentId+'">'+
	    		'<div class="diffLoadingView"><div class="loading-mask-text">'+loadingText+'</div></div>'+
	    		//'<div class="single-msg"><img class="img-loading" src="'+basePath+'/resources/img/loading.gif" style="width:16px;height:16px;margin-right:5px;margin-top:-2px"> Loading...</div>' +
	    		'</div>'+
	    		'<div id="diffSummary" style="display:none"></div>'
	    }],
	    showedDiffContents: function(panel) {
	    	panel.tools['maximize'].show();
	    	panel.setSize({height:'90%', width:'85%'});
	    	panel.center();
	    	panel.adjustInnerScrollHeight();
	    },
	    adjustInnerScrollHeight: function() {
	    	$('#repoDiffContent').height(this.body.getHeight()); // for inner scroll
	    },
	    listeners: {
	    	show: function(panel) {
	    		RepoUtil.lockScroll();
	    		panel.tools['maximize'].hide();
	    		panel.updateLayout();
				Ext.on('resize', RepoUtil.resizeBrowserWinHandler);
	            if (panel.modal) {
	            	if (Ext.WindowMgr.mask)
	            		Ext.WindowMgr.mask.addCls('dark');
	            }
				panel.focus();
				loadFileDetailsForComparison(target, fieldData, repoDiffContentId);
	    	},
	    	maximize: function(panel, eOpts) {
	    		panel.center();
	    	},
	    	restore: function(panel, eOpts) {
	    		panel.center();
	    	},
			destroy: function(panel, eOpts) {
	    		RepoUtil.unlockScroll();
	    		Ext.un('resize', RepoUtil.resizeBrowserWinHandler);
	            if (panel.modal) {
	            	if (Ext.WindowMgr.mask)
	            		Ext.WindowMgr.mask.removeCls('dark');
	            }
			},
	    	resize: function(panel) {
	    		Ext.defer(function(){
	    			panel.updateLayout();
	    			panel.adjustInnerScrollHeight();
	    		}, 100);
	    	}
	    }
	}).show(target);
}

RepoUtil.resizeBrowserWinHandler = function() {
	var win = Ext.first('#repoDiffWin');
	if (win)
		win.fireEvent('resize', win);
};
