
CREATE TABLE `plugin_mst_repository_error` (
  `repo_id` int(11) NOT NULL,
  `error_id` int(11) DEFAULT NULL,
  `update_date` datetime DEFAULT NULL,
  `error_info_en` varchar(500) DEFAULT NULL,
  `error_info_ja` varchar(500) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `plugin_mst_repository_settings` (
  `repo_id` int(11) NOT NULL AUTO_INCREMENT,
  `service_id` int(11) NOT NULL,
  `setting_enable` int(11) DEFAULT NULL,
  `repository_type` int(11) DEFAULT NULL,
  `repository_name` varchar(50) NOT NULL,
  `repository_path` varchar(500) DEFAULT NULL,
  `username` varchar(45) DEFAULT NULL,
  `password` varchar(100) DEFAULT NULL,
  `private_key` varchar(8192) DEFAULT NULL,
  `passphrase` varchar(200) DEFAULT NULL,
  `port_number` int(11) DEFAULT NULL,
  `update_date` datetime DEFAULT NULL,
  `update_user` int(11) DEFAULT NULL,
  `sync_date` datetime DEFAULT NULL,
  PRIMARY KEY (`repo_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `plugin_tran_bug` (
  `repo_id` int(11) NOT NULL,
  `project_id` int(11) NOT NULL,
  `bug_id` int(11) NOT NULL,
  `repo_revision_id` int(11) NOT NULL,
  PRIMARY KEY (`repo_id`,`project_id`,`bug_id`,`repo_revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `plugin_tran_repository_file` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `revision_id` int(11) NOT NULL,
  `ext_file_name` varchar(2560) DEFAULT NULL,
  `change_type` int(11) DEFAULT NULL,
  `line_count` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_rev` (`revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `plugin_tran_repository_revision` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `repo_id` int(11) NOT NULL,
  `ext_revision` varchar(100) NOT NULL,
  `author` varchar(100) DEFAULT NULL,
  `message` varchar(500) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_bug` (`repo_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `plugin_mst_repository_using_project` (
  `repo_id` int(11) NOT NULL,
  `project_id` int(11) NOT NULL,
  PRIMARY KEY (`repo_id`,`project_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;